<template>
  <form class="block-form" @submit.prevent="onSubmit">
    <div class="form-row">
      <h4 class="form-title">Для какого транспортного средства</h4>
      <ob-radio label="Прицеп" valueInput="TRAILER" v-model="formData.vehicleType" :disabled="!isNew" />
      <ob-radio label="Тягач или фургон" valueInput="TRUCK" v-model="formData.vehicleType" :disabled="!isNew" />
    </div>

    <div class="form-row">
      <ob-checkbox label="Госномер РФ" v-model="isRussianNumber" :disabled="!isNew" @change="onNumberMaskChange" />
      <ob-input ref="number" label="Регистрационный номер" required v-model.trim="formData.vehicleNumber" :mask="carNumberMask" :mask-tokens="regnumMaskTokens" :disabled="!isNew" @keydown.native="validateNumber" @keyup.native="capitalizeNumber" />
      <ob-alert
        v-if="isVehicleError"
        :text="error.message"
        icon="alert"
        hide-close-button
        theme="warning"
      />
    </div>

    <div class="form-row">
      <h4 class="form-title">Номер бортового блока</h4>
      <ob-input label="Укажите номер ББ" required v-model="formData.imei" :disabled="isNew && !formData.vehicleNumber.length || isVehicleError" @input="validateBlock" />
      <ob-alert
        v-if="isBlockError"
        :text="error.message"
        icon="alert"
        hide-close-button
        :theme="error.code == 110 ? 'danger' : 'warning'"
      />
    </div>

    <div class="form-row">
      <h4 class="form-title">Перевозчики</h4>
      <ob-select
        label="Перевозчики, использующие это ТС"
        v-model="carriers"
        isDropdown
        isAutoComplete
        :remote-opt="{
          method: getCarriers
        }"
        @input="onSetCarriers"
      />
    </div>

    <div class="form-row form-row--actions">
      <ob-button :label="isNew ? 'Добавить' : 'Сохранить'" :disabled="isFormBlocked" />
      <ob-button label="Отмена" type="flat" @click.native.prevent="onClose" />
    </div>
  </form>
</template>

<script>
import debounce from 'debounce';
import { uuid } from "vue-uuid";
import api from '@/api';

import mask from 'common-components/src/obComponents/obMask/directives/mask.js';
import obRadio from 'common-components/src/obComponents/obRadio';
import obCheckbox from 'common-components/src/obComponents/obCheckbox';
import obInput from 'common-components/src/obComponents/obInput';
import obAlert from 'common-components/src/obComponents/obAlert';
import obSelect from 'common-components/src/obComponents/obSelect';
import obButton from 'common-components/src/obComponents/obButton';

  export default {
    name: 'block',

    props: {
      selectedBlock: {
        type: Object
      },
      isNew: {
        type: Boolean,
        default: true
      }
    },

    components: {
      obRadio,
      obCheckbox,
      obInput,
      obAlert,
      obSelect,
      obButton
    },

    data() {
      return {
        regnumMaskTokens: {
          '0': { pattern: /\d/ },
          'A': {
            pattern: /[ABEKMHOPCTXYАВЕКМНОРСТУХ]/i,
            transform: v => v.toLocaleUpperCase()
          }
        },
        backup: {
          vehicleNumber: '',
          vehicleType: '',
          imei: '',
          carriers: []
        },
        isRussianNumber: false,
        carriers: [],
        formData: {
          vehicleNumber: '',
          vehicleType: '',
          imei: '',
          carriers: []
        },
        error: {
          code: '',
          message: ''
        },
      }
    },

    directives: {
      mask
    },

    computed: {
      isFormDirty() {
        const { vehicleNumber, vehicleType, imei, carriers } = this.formData;
        return JSON.stringify({vehicleNumber, vehicleType, imei, carriers}) !== JSON.stringify(this.backup);
      },

      isFormEmpty() {
        return !this.formData.vehicleType || !this.formData.vehicleNumber || !this.formData.imei
      },

      carNumberMask() {
        const numberMasksMap = {
          'TRUCK': 'A 000 AA 00(0)',
          'TRAILER': 'AA 0000 00(0)'
        }
        return this.isRussianNumber ? numberMasksMap[this.formData.vehicleType] : '';
      },

      isVehicleError() {
        return !!(this.error.code && this.error.code === "100" || this.error.code && this.error.code === "106" || this.error.code && this.error.code === "203")
      },

      isBlockError() {
        return !!(this.error.code && this.error.code === "103" || this.error.code && this.error.code === "105" || this.error.code && this.error.code === "110" || this.error.code && this.error.code === "201");
      },

      isFormBlocked() {
        return !!((this.error.code.length && +this.error.code < 200) || !this.formData.vehicleNumber || !this.formData.imei || !this.formData.vehicleType || !this.isFormDirty) 
      },
    },

    watch: {
      selectedBlock: {
        handler: function(newVal) {
          if (newVal) {
            const { vehicleNumber, vehicleType, imei, carriers } = newVal;
            // this.backup = JSON.stringify({vehicleNumber, vehicleType, imei, carriers});

            this.backup = { vehicleNumber, vehicleType, imei, carriers: carriers.map(item => ({uuid: item.uuid})) }

            this.formData = { vehicleNumber, vehicleType, imei, carriers: carriers.map(item => ({uuid: item.uuid})) }

            this.carriers = carriers.map(item => item.uuid);
            this.isRussianNumber = false;
          } else {
            this.formData.vehicleNumber = '';
            this.formData.vehicleType = 'TRUCK';
            this.formData.imei = '';
            this.formData.carriers = [];
            this.isRussianNumber = true;
            this.carriers = [];
          }
        },
        immediate: true
      },
    },

    methods: {
      async getCarriers() {
        try {
          const res = await api.tracking.getBlockCarriers();
          return res;
        } catch (err) {
          console.error(err);
        }
      },

      onSetCarriers() {
        this.formData.carriers = this.carriers.map(item => ({uuid: item}))
      },

      async onNumberMaskChange($event) {
        await this.$nextTick();
        if ($event) {
          this.$refs.number.$children[0].$refs.input.focus();
        } else {
          this.$refs.number.localValue = this.formData.vehicleNumber.replace(/\s/g, '')
          this.$refs.number.focus();
        }
      },

      validateNumber(e) {
        if (this.isRussianNumber) {
          this.validateBlock();
          return;
        }

        const reg = new RegExp(/[A-Z\d]/g);
        const correctNumber = e.key.toUpperCase().match(reg);
        if (!correctNumber) {
          e.preventDefault();
        } else {
          this.validateBlock();
        }
      },

      capitalizeNumber() {
        this.formData.vehicleNumber = this.formData.vehicleNumber.toUpperCase();
      },

      validateBlock: debounce(async function() {
        this.error.code = '';
        this.error.message = '';
        try {
          const res = await api.tracking.validateBlock(this.formData.vehicleNumber, this.formData.imei)
          if (res.errorCode) {
            this.setError(res.errorCode, res.description);
          }
        } catch (err) {
          console.error(err)
        }
      }, 1000),

      setError(code, description) {
        const errorsMap = {
          "100": `Это ТС уже имеет бортовой блок и относится к перевозчикам: ${description}`,
          "103": `Этот номер ББ используется на другом вашем ТС: ${description}`,
          "105": `Этот номер ББ используется на другом вашем ТС: ${description}`,
          "106": `На этом ТС используется другой ББ: ${description}`,
          "110": `Указанный номер IMEI бортового устройства не зарегистрирован в нашей системе. Воспользуйтесь <a href="/">инструкцией для подключения и настройки</a>`,
          "201": `Этот бортовой блок установлен на ТС другого перевозчика. Номер ТС будет использован автоматически`,
          "203": `Этот ТС принадлежит другому перевозчику и уже имеет бортовой блок. Его номер будет использован автоматически`
        }
        this.error = {
          code: code,
          message: errorsMap[code]
        }
      },

      translit(string) {
        const text = string
        .replace(/\u0410/g, 'A')
        .replace(/\u0412/g, 'B')
        .replace(/\u0415/g, 'E')
        .replace(/\u041A/g, 'K')
        .replace(/\u041C/g, 'M')
        .replace(/\u041D/g, 'H')
        .replace(/\u041E/g, 'O')
        .replace(/\u0420/g, 'P')
        .replace(/\u0421/g, 'C')
        .replace(/\u0422/g, 'T')
        .replace(/\u0423/g, 'Y')
        .replace(/\u0425/g, 'X');

        return text;
      },

      async onSubmit() {
        if (this.isNew) {
          const blockUuid = this.selectedBlock?.uuid || uuid.v4();
          if (!this.error.code || (this.error.code !== 202 && this.error.code !== 203)) {
            try {
              const number = this.translit(this.formData.vehicleNumber.replace(/\s/g, ''));
              await api.tracking.addBlock(blockUuid, { ...this.formData, vehicleNumber: number })
              this.$emit('submit', this.formData);
            } catch (err) {
              console.error(err);
              if (err.error) {
                this.setError(err.error.errorCode, err.error.description);
              }
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка при сохранении",
              });
            }
          }
  
          if (this.error.code && this.error.code === 202) {
            try {
              await api.tracking.addBlockConnection(this.formData.imei)
            } catch (err) {
              console.error(err);
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка при сохранении",
              });
            }
          }
  
          if (this.error.code && this.error.code === 204) {
            try {
              await api.tracking.addBlockCarriers(this.formData.imei)
            } catch (err) {
              console.error(err);
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка при сохранении",
              });
            }
          }
        } else {
            try {
              await api.tracking.addBlockCarriers(this.formData.imei, this.formData.carriers);
              this.$emit('submit', this.formData);
            } catch (err) {
              console.error(err);
              if (err.error) {
                this.setError(err.error.errorCode, err.error.description);
              }
              this.$notification({
                type: "system_notification_error",
                message: "Ошибка при сохранении",
              });
            }
        }
        // this.$emit('submit');
      },

      onClose() {
        this.error.code = '';
        this.error.message = '';
        this.formData.vehicleNumber = '';
        this.formData.vehicleType = 'TRUCK';
        this.formData.imei = '';
        this.formData.carriers = [];
        this.$emit('close') 
      }
    }
  }
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.form-row {
  margin-top: 30px;

  &:first-child {
    margin-top: 0;
  }

  &--actions {
    display: flex;
    margin-top: 40px;

    &::v-deep {
      .ob-button-container:not(:last-child) {
        margin-right: 15px;
      }
    }
  }
  &::v-deep {
    .ob-alert-container {
      margin-top: 20px;
    }

    a {
      color: $blue-700;
      text-decoration: none;
    }
  }
}

.form-title {
  margin-bottom: 10px;
  @include font-mixin(16px, 20px, 700, $style-black);
}

.ob-radio-container.radio-wrapper:not(:first-child) {
  margin-top: 5px;
}

.ob-checkbox-container.checkbox-wrapper {
  margin-bottom: 5px;
}

.number-input {
  width: 100%;
  height: 42px;
  position: relative;

  input {
    width: 100%;
    height: 42px;
    padding: 8px 12px;
    border: 1px solid red;
    font-size: 16px;
    font-family: inherit;
    color: transparent;
    caret-color: #000;
  }

  &__content {
    width: calc(100% - 2px);
    height: 40px;
    padding: 0 12px;
    position: absolute;
    top: 1px;
    left: 1px;
    background-color: transparent;
    pointer-events: none;
    font-size: 16px;
    line-height: 39px;
  }
}
</style>